import { Group, GroupSpec, IGroup } from "./group.js";
export interface IApplication extends IGroup {
    run: (input?: string[]) => void;
}
export interface ApplicationSpec extends GroupSpec {
    version?: string;
}
export declare class Application extends Group implements IApplication {
    protected _version?: string;
    private _version_middleware;
    /**
     * Application constructor
     * @param spec - Application configuration
     * @returns Application object
     */
    constructor(spec?: ApplicationSpec);
    /**
     * Parse console input & run
     * @param input - User input
     * @returns void
     */
    run(input?: string[]): void;
}
