"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Application = void 0;
// ================================ Imports ================================ //
const dntShim = __importStar(require("../_dnt.shims.js"));
const group_js_1 = require("./group.js");
// =========================== Application Class =========================== //
class Application extends group_js_1.Group {
    _version;
    // -------------------------- Private Methods -------------------------- //
    _version_middleware(ctx, next) {
        if (ctx.flags.version && this?._version)
            console.log(this._version);
        else
            next();
    }
    // ---------------------------- Constructor ---------------------------- //
    /**
     * Application constructor
     * @param spec - Application configuration
     * @returns Application object
     */
    constructor(spec) {
        super(spec);
        this._version = spec?.version;
        this.use(this._version_middleware);
        this._options.push({
            name: "--help",
            alias: "-h",
            description: "Show the help menu",
            flag: true,
        });
        if (this._version) {
            this._options.push({
                name: "--version",
                alias: "-v",
                description: "Show the version",
                flag: true,
            });
        }
    }
    // --------------------------- Public Methods --------------------------- //
    /**
     * Parse console input & run
     * @param input - User input
     * @returns void
     */
    run(input = dntShim.Deno.args) {
        this._run(input);
    }
}
exports.Application = Application;
